import java.awt.*;
import java.lang.*;
import java.io.*;

	class VacaGui extends Frame {
		TextField a1,a2,a3,a4;
		Button c1,c2,c3;
		Label l1,l2,l3,l4,l5;
		VacaCalculs calcul = null ;
		String nom = "sensenom.dat";
		boolean plot = false;
		boolean eps = false;
		float dt = 0.05f;
		int imax = 140;
		float qp = 5000.0f;
		float dur = 3.5f;

		VacaGui(String windowTitle) {
			super(windowTitle);
		}

		public void init() {
			setLayout(new GridLayout(0,2,10,10));
			a1 = new TextField(Float.toString(dt));
			a2 = new TextField(Integer.toString(imax));
			a3 = new TextField(Float.toString(qp));
			a4 = new TextField(Float.toString(dur));
			c1 = new Button("Calcular");
			c2 = new Button("Guardar");
			c3 = new Button("Sortir");
			l1 = new Label("Pas de temps (d)");
			l2 = new Label("Passos que vols calcular");
			l3 = new Label("Concentracio a l'herba (Bq/kg)");
			l4 = new Label("Duracio de la contaminacio (d)");
			l5 = new Label("");
			add(l1);
			add(a1);
			add(l2);
			add(a2);
			add(l3);
			add(a3);
			add(l4);
			add(a4);
			add(c1);
			add(c2);
			add(c3);
			add(l5);
			pack();
			c2.disable();
		}

		public boolean action(Event evt,Object arg) {
			if(evt.target instanceof Button)
				return accioBoto((String)arg);
			if(evt.target instanceof TextField)
				return accioCamp((TextField)evt.target);
			return true;
		}

		public boolean accioBoto(String label) {
			if(label.equals("Calcular"))
				calcular();
			if(label.equals("Guardar"))
				guardar();
			if(label.equals("Sortir"))
				System.exit(0);
			return true;
		}

		public boolean accioCamp(TextField field) {
			return true;
		}

		public void calcular() {
			Float f1,f3,f4;
			int m;

			f1 = Float.valueOf(a1.getText());
			f3 = Float.valueOf(a3.getText());
			f4 = Float.valueOf(a4.getText());
			dt = f1.floatValue();
			imax = Integer.parseInt(a2.getText());
			qp = f3.floatValue();
			dur = f4.floatValue();
			calcul = new VacaCalculs(dt,imax,qp,dur);
			if(plot) {
				System.out.println("set data style lines");
				System.out.println("plot '-','-','-','-'");
				for(m=0;m<imax;m++)
					System.out.println(Double.toString(calcul.temps[m]) + " " + Double.toString(calcul.conc[m][0]));
				System.out.println("e");
				for(m=0;m<imax;m++)
					System.out.println(Double.toString(calcul.temps[m]) + " " + Double.toString(calcul.conc[m][1]));
				System.out.println("e");
				for(m=0;m<imax;m++)
					System.out.println(Double.toString(calcul.temps[m]) + " " + Double.toString(calcul.conc[m][2]));
				System.out.println("e");
				for(m=0;m<imax;m++)
					System.out.println(Double.toString(calcul.temps[m]) + " " + Double.toString(calcul.conc[m][3]));
				System.out.println("e");
			}
			c2.enable();
		}

		public void guardar() {
			File fitxersortida;		// declaraci d'instncies locals
			FileWriter sortida;
			String linia;
			boolean escriure = true;	// declaraci de variables locals
			int k,m;

			try {
				fitxersortida = demanarFitxer();
				if (fitxersortida != null) {
					escriure = !fitxersortida.exists();
					if (!escriure)
						escriure = demanarConfirmacio();
					if(escriure) {
						sortida = new FileWriter(fitxersortida);
						if(eps) {
							sortida.write("set terminal postscript eps color \n");
							sortida.write("set output '"+nom+".eps' \n");
							sortida.write("plot '-' using 1:2 with lines, '-' using 1:3 with lines, '-' using 1:4 with lines, '-' using 1:5 with lines \n");
						}
						k=0;
						do {
							for(m=0;m<imax;m++) {
								linia=Double.toString(calcul.temps[m]) + " " + Double.toString(calcul.conc[m][0]) + " " + Double.toString(calcul.conc[m][1]) + " " + Double.toString(calcul.conc[m][2]) + " " + Double.toString(calcul.conc[m][3]) + "\n";
								sortida.write(linia);
							}
							if(eps) {
								sortida.write("e \n");
							}
							k++;
						} while((k<4)&&(eps));
						sortida.close();
					}
				}
			} catch (IOException e){}
		}

		public boolean demanarConfirmacio() {
			VacaDialegConfirmar confirmar = null ;		// declaraci d'instncies locals
			boolean opcio = false;

			if (confirmar == null)
				confirmar = new VacaDialegConfirmar(this);
			confirmar.show();
			opcio = confirmar.getOpcio();
			return opcio;
		}

		public File demanarFitxer() {
			FileDialog escollirfitxer = null ;	// declaraci d'instncies locals
			File fitxer;
			String nomdirectori = "./";

			fitxer = new File(nomdirectori,nom);
			try {
				escollirfitxer = new FileDialog(this,"Guardar",escollirfitxer.SAVE);
				escollirfitxer.setFile(nom);
				escollirfitxer.show();
				nom = escollirfitxer.getFile();
				nomdirectori = escollirfitxer.getDirectory();
				fitxer = new File(nomdirectori,nom);
			} catch (NullPointerException e) {
				fitxer = null;
				nom = "sensenom.dat";
			}
			return fitxer;
		}

    		public boolean handleEvent(Event evt) {
        		switch (evt.id) {
				case Event.WINDOW_DESTROY:
					System.exit(0);
        		}
        		return super.handleEvent(evt);
    		}
	}

	class VacaDialegConfirmar extends Dialog {
		Button c1;
		Button c2;
		Label l1;
		boolean opcio = false;

		VacaDialegConfirmar(Frame progenitora) {
			super(progenitora,"Confirmar",true);
			setLayout(new GridLayout(0,1,10,10));
			c1 = new Button("D'acord");
			c2 = new Button("Cancel.lar");
			l1 = new Label ("  El fitxer ja existeix. Sobreescriure?");
			add(l1);
			add(c1);
			add(c2);
			pack();
		}

		public boolean action(Event evt,Object arg) {
			if(evt.target instanceof Button)
				return accioBoto((String)arg);
			return true;
		}

		public boolean accioBoto(String label) {
			if(label.equals("D'acord")) {
				opcio = true;
				hide();
			}
			if(label.equals("Cancel.lar")) {
				opcio = false;
				hide();
			}
			return true;
		}

		public boolean getOpcio() {
		return opcio;
		}
	}

class Vaca {

	public static void main(String args[]) {
		VacaGui vaca = null;		// Declaraci d'instncies.

		vaca = new VacaGui("Vaca");
		for(int i = 0 ; i < args.length ; i++) {
			if(args[i].equals("-p") || args[i].equals("--gnuplot"))
				vaca.plot = true;
			if(args[i].equals("-e") || args[i].equals("--eps"))
				vaca.eps = true;
		}
		vaca.init();
		vaca.show();
	}
}

